### Alpas - The Rapid and Delightful Kotlin Web Framework. Easy, elegant, and productive! 🚀

Alpas is a batteries-included web framework for Kotlin with a strong focus on developers' productivity.
The main goal of Alpas is to get you started quick and enable you to move faster while
letting you enjoy doing what you are the best at — crafting a delightful web app.

Alpas strives to be simple and elegant and wants to serve you whether you have written any JVM based web
apps before or not—there is no xml or properties files to configure, no scattered annotations
to memorize—and yet, there is no huge learning curve to get started.

Alpas comes bundled with most of what you need to write modern web apps—**authentication**,
**auth scaffolding**, **email verification**, **notifications**, **mail**, **queues**,
**fast and intuitive routing**, **powerful templating engine** etc.—and yet it
remains flexible for you to extend it to make it more powerful and
delightful than it already is.

We have sweated picking the good parts, so you don’t have to!

### Who is Alpas for?

Alpas is for you if you are looking to learn some dynamic web development.

If you are tired of the complexities of a dynamic web programming ecosystem, Alpas is for you.

If you are tired of gigantic "enterprisey" web frameworks, Alpas is for you. 

If you just want to enjoy writing a web app using a ["happy programming language"][happy-kotlin] with a
framework that has everything you need but still gets out of your way, then Alpas is definitely for you!

### Learning Alpas

Alpas is extensively and meticulously documented; and, no, we are not just talking about code
comments and hand-waving! We have put as much effort writing and updating the documentation as
we have spent time crafting the framework, and we are proud of it!

The [Alpas documentation site][alpas-docs] has everything you need to get started and get going—including
two full featured tutorials showing you how to write web apps from start to finish.

If you are not satisfied with the quality of Alpas documentation or feel like something is not properly
documented, please open an issue, and we'll tackle it with a high priority. Feel free to send a pull
request if you want, of course!

We want you to enjoy writing a web app in Alpas. If you are not, please let us know, and we'll keep it
improving until it is just right for all of us. The best way to let us help you is by joining our 
[official Slack][alpas-slack] and asking questions. [Please do!][alpas-slack].


[happy-kotlin]: https://medium.com/signal-v-noise/kotlin-makes-me-a-happier-better-programmer-1fc668724563
[alpas-slack]: https://join.slack.com/t/alpasdev/shared_invite/enQtODcwMjE1MzMxODQ3LTJjZWMzOWE5MzBlYzIzMWQ2MTcxN2M2YjU3MTQ5ZDE4NjBmYjY1YTljOGIwYmJmYWFlYjc4YTcwMDFmZDIzNDE
[alpas-docs]: https://alpas.dev/docs

